
#property copyright "Martin Lemire, phover "
#property link      "mlemire12@videotron.ca "

#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 0.2
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Crimson

string Gs_76 = "TheSecretTR";
extern int ADX_period = 20;
extern int MOM_period = 20;
extern int MACD_fast_ema = 5;
extern int MACD_slow_ema = 15;
extern int MACD_signal_period = 9;
extern int MaxBarsOnGraph = 500;
double Gda_108[];
double Gda_112[];
double Gda_116[];
double Gda_120[];
double Gda_124[];
double Gda_128[];
double Gda_132[];
double Gda_136[];
double Gd_140;
double Gd_148;
double Gd_156;
double Gd_164;
double Gd_172;
int Gi_180;
int Gi_184;
int Gi_188;
int Gi_196;
int Gi_200;
int Gi_204;
int Gi_208;
int Gi_228;
int Gi_232;
int Gi_236;
int Gi_240;
int Gi_244 = 0;
int Gi_248;
int Gi_256;
int Gi_260 = -1;
string Gs_264;
string Gs_272 = "TheSecret Trend Reversal";
string Gs_280;

int init() {
   IndicatorShortName(Gs_272);
   SetIndexStyle(0, DRAW_ARROW, STYLE_SOLID, 0);
   SetIndexArrow(0, 108);
   SetIndexBuffer(0, Gda_108);
   SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID, 0);
   SetIndexArrow(1, 108);
   SetIndexBuffer(1, Gda_112);
   SetIndexEmptyValue(0, 0);
   SetIndexEmptyValue(1, 0);
   Gi_228 = 0;
   Gi_232 = 0;
   Gi_236 = 0;
   Gi_240 = 0;
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   Gi_244++;
   Gi_248 = IndicatorCounted();
   if (Gi_248 < 0) return (-1);
   Gi_256 = WindowFind(Gs_272);
   if (Gi_180 != Bars) NewBar();
   if (Gi_248 > 0) Gi_248--;
   Gi_184 = Gi_180 - Gi_248 - 1;
   if (Gi_184 > MaxBarsOnGraph) Gi_184 = MaxBarsOnGraph;
   for (Gi_188 = Gi_184 - 1; Gi_188 >= 0; Gi_188--) {
      Gd_140 = iADX(NULL, 0, ADX_period, PRICE_CLOSE, MODE_PLUSDI, Gi_188);
      Gd_148 = iADX(NULL, 0, ADX_period, PRICE_CLOSE, MODE_MINUSDI, Gi_188);
      Gd_156 = iADX(NULL, 0, ADX_period, PRICE_CLOSE, MODE_MAIN, Gi_188);
      Gd_164 = iMomentum(NULL, 0, MOM_period, PRICE_CLOSE, Gi_188);
      Gd_172 = iMACD(NULL, 0, MACD_fast_ema, MACD_slow_ema, MACD_signal_period, PRICE_CLOSE, MODE_MAIN, Gi_188);
      if (Gd_140 >= Gd_148) {
         Gda_116[Gi_188] = 0.1;
         if (Gi_196 == -1 || Gi_196 == 0) {
            Gi_196 = 1;
            Gi_228 = TimeCurrent();
         }
      }
      if (Gd_140 < Gd_148) {
         Gda_120[Gi_188] = 0.1;
         if (Gi_196 == 1 || Gi_196 == 0) {
            Gi_196 = -1;
            Gi_228 = TimeCurrent();
         }
      }
      if (Gd_164 >= 100.0) {
         Gda_124[Gi_188] = 0.3;
         if (Gi_200 == -1 || Gi_200 == 0) {
            Gi_200 = 1;
            Gi_232 = TimeCurrent();
         }
      }
      if (Gd_164 < 100.0) {
         Gda_128[Gi_188] = 0.3;
         if (Gi_200 == 1 || Gi_200 == 0) {
            Gi_200 = -1;
            Gi_232 = TimeCurrent();
         }
      }
      if (Gd_172 >= 0.0) {
         Gda_132[Gi_188] = 0.5;
         if (Gi_204 == -1 || Gi_204 == 0) {
            Gi_204 = 1;
            Gi_236 = TimeCurrent();
         }
      }
      if (Gd_172 < 0.0) {
         Gda_136[Gi_188] = 0.5;
         if (Gi_204 == 1 || Gi_204 == 0) {
            Gi_204 = -1;
            Gi_236 = TimeCurrent();
         }
      }
      if (Gi_196 == 1 && Gi_200 == 1 && Gi_204 == 1) Gi_208 = 1;
      if (Gi_196 == -1 && Gi_200 == -1 && Gi_204 == -1) Gi_208 = -1;
      if (Gi_208 == 1) Gda_108[Gi_188] = 0.08;
      else Gda_112[Gi_188] = 0.08;
   }
   WindowRedraw();
   return (0);
}

void NewBar() {
   Gi_180 = Bars;
   Gi_248++;
}
